/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_ALWAYS_20070922_1800)
#define BOOST_TRAVERSAL_ALWAYS_20070922_1800

namespace boost { namespace traversal { namespace detail {
    template<typename UnaryFunc>
    struct always
    {
        explicit always(UnaryFunc f)
            : f(f)
        {}

        template<typename U>
        bool operator()(U& u) const
        {
            f(u);
            return false;
        }

        UnaryFunc f;
    };

    template<typename UnaryFunc>
    always<UnaryFunc> make_always(UnaryFunc f)
    {
        return always<UnaryFunc>(f);
    }
}}}

#endif
