/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_GRAB_PTR_20070922_1720)
#define BOOST_TRAVERSAL_GRAB_PTR_20070922_1720

#include <boost/shared_ptr.hpp>
#include <boost/weak_ptr.hpp>
#include <memory>

namespace boost { namespace traversal { namespace detail {
    template<typename T>
    struct grab_ptr
    {
        explicit grab_ptr(T& ptr)
            : ptr(ptr)
        {}

        T& ptr;
    };

    template<typename T>
    struct grab_ptr<boost::weak_ptr<T> >
    {
        explicit grab_ptr(boost::weak_ptr<T>& ptr)
            : ptr(ptr)
        {}
      
        boost::shared_ptr<T> ptr;
    };

    template<typename T>
    struct grab_ptr<boost::weak_ptr<T> const>
    {
        explicit grab_ptr(boost::weak_ptr<T> const& ptr)
            : ptr(ptr)
        {}
      
        boost::shared_ptr<T> ptr;
    };

    template<typename T>
    struct grab_ptr<std::auto_ptr<T> >
    {
        explicit grab_ptr(std::auto_ptr<T>& ptr)
            : ptr(ptr.get())
        {}

        T* ptr;
    };

    template<typename T>
    struct grab_ptr<std::auto_ptr<T> const>
    {
        explicit grab_ptr(std::auto_ptr<T> const& ptr)
            : ptr(ptr.get())
        {}

        T* ptr;
    };
}}}

#endif
