/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_REVERSE_ONE_20070922_1748)
#define BOOST_TRAVERSAL_REVERSE_ONE_20070922_1748

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/one.hpp>
#include <boost/traversal/horizontal/detail/fusion_one.hpp>
#include <boost/traversal/horizontal/detail/iter_one.hpp>
#include <boost/fusion/view/reverse_view.hpp>

namespace boost { namespace traversal { namespace extension {
    template<typename T, typename UnaryFunc, typename Tag>
    bool reverse_one(T& t, UnaryFunc f, Tag tag)
    {
        return extension::one(t, f, tag);
    }

    template<typename T, typename UnaryFunc>
    bool reverse_one(T& t, UnaryFunc f, traits::container_tag)
    {
        return detail::iter_one(t.rbegin(), t.rend(), f);
    }

    template<typename T, typename UnaryFunc>
    bool reverse_one(T& t, UnaryFunc f, traits::fusion_sequence_tag)
    {
        fusion::reverse_view<T> r(t);
        return detail::fusion_one(r, f);
    }
}}}

#endif
