/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_REVERSE_ONE_20070922_1705)
#define BOOST_TRAVERSAL_TU_REVERSE_ONE_20070922_1705

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/tu_one.hpp>
#include <boost/traversal/horizontal/detail/fusion_tu_one.hpp>
#include <boost/traversal/horizontal/detail/iter_tu_one.hpp>
#include <boost/fusion/view/reverse_view.hpp>
#include <utility>

namespace boost { namespace traversal { namespace extension {
    template<typename T, typename UnaryFunc, typename State, typename Tag>
    State tu_reverse_one(T& t, UnaryFunc f, State state, Tag tag)
    {
        return extension::tu_one(t, f, state, tag);
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_reverse_one(T& t, UnaryFunc f, State state, traits::container_tag)
    {
        return detail::iter_tu_one(t.rbegin(), t.rend(), f, state);
    }

    template<typename T, typename UnaryFunc, typename State>
    State tu_reverse_one(T& t, UnaryFunc f, State state, traits::fusion_sequence_tag)
    {
        fusion::reverse_view<T> r(t);
        return detail::fusion_tu_one(r, f, state);
    }
}}}

#endif
