/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_VARIANT_TU_ONE_20070924_1751)
#define BOOST_TRAVERSAL_VARIANT_TU_ONE_20070924_1751

#include <boost/variant.hpp>

namespace boost { namespace traversal { namespace detail {
    template<typename UnaryFunc, typename State>
    struct tu_visitor_wrapper
        : boost::static_visitor<State>
    {
        explicit tu_visitor_wrapper(UnaryFunc func, State state)
            : func(func), state(state)
        {}

        template<typename U>
        State operator()(U& u) const
        {
            return func(state, u);
        }

        UnaryFunc func;
        State state;
    };

    template<typename UnaryFunc, typename State>
    tu_visitor_wrapper<UnaryFunc, State>
    make_tu_visitor(UnaryFunc func, State state)
    {
        return tu_visitor_wrapper<UnaryFunc, State>(func, state);
    }

    template<typename T, typename UnaryFunc, typename State>
    State variant_tu_one(T& t, UnaryFunc f, State state)
    {
        return boost::apply_visitor(detail::make_tu_visitor(f, state), t);
    }
}}}

#endif
