/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_ONE_20070922_1659)
#define BOOST_TRAVERSAL_ONE_20070922_1659

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/one.hpp>

namespace boost { namespace traversal {
    struct one_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc, typename Tag>
        bool operator()(T& t, UnaryFunc f, Tag tag) const
        {
            return extension::one(t, f, tag);
        }

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return (*this)(t, f, typename traits::tag_of<T>::type());
        }
    };

    one_traversal const one = {};
}}

#endif
