/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_REVERSE_ALL_20070922_1758)
#define BOOST_TRAVERSAL_REVERSE_ALL_20070922_1758

#include <boost/traversal/horizontal/reverse_one.hpp>
#include <boost/traversal/horizontal/detail/always.hpp>

namespace boost { namespace traversal {
    struct reverse_all_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc, typename Tag>
        bool operator()(T& t, UnaryFunc f, Tag tag) const
        {
            return reverse_one(t, detail::make_always(f), tag);
        }

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return reverse_one(t, detail::make_always(f));
        }
    };

    reverse_all_traversal const reverse_all = {};
}}

#endif
