/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_REVERSE_ONE_20070922_1659)
#define BOOST_TRAVERSAL_TU_REVERSE_ONE_20070922_1659

#include <boost/traversal/support/tag_of.hpp>
#include <boost/traversal/horizontal/detail/tu_reverse_one.hpp>

namespace boost { namespace traversal {
    struct tu_reverse_one_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State>
        struct result<tu_reverse_one_traversal(T&, UnaryFunc, State)>
        {
            typedef std::pair<State, bool> type;
        };

        template<typename T, typename UnaryFunc, typename State, typename Tag>
        struct result<tu_reverse_one_traversal(T&, UnaryFunc, State, Tag)>
        {
            typedef std::pair<State, bool> type;
        };

        template<typename T, typename UnaryFunc, typename State, typename Tag>
        std::pair<State, bool>
        operator()(T& t, UnaryFunc f, State state, Tag tag) const
        {
            return extension::tu_reverse_one(t, f, std::make_pair(state, false), tag);
        }

        template<typename T, typename UnaryFunc, typename State>
        std::pair<State, bool>
        operator()(T& t, UnaryFunc f, State state) const
        {
            return (*this)(t, f, state, typename traits::tag_of<T>::type());
        }
    };

    tu_reverse_one_traversal const tu_reverse_one = {};
}}

#endif
