/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_BU_REVERSE_FULL_20070922_1919)
#define BOOST_TRAVERSAL_BU_REVERSE_FULL_20070922_1919

#include <boost/traversal/horizontal/reverse_all.hpp>
#include <boost/traversal/recursive/traverse.hpp>
#include <boost/traversal/recursive/detail/sequence.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct bu_reverse_full_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse(t, false_, f, reverse_all, detail::sequence);
        }

        template<typename T, typename UnaryFunc, typename All>
        bool operator()(T& t, UnaryFunc f, All const& reverse_all) const
        {
            return traverse(t, false_, f, reverse_all, detail::sequence);
        }
    };

    bu_reverse_full_traversal const bu_reverse_full = {};
}}

#endif
