/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_BU_SPINE_20070924_1708)
#define BOOST_TRAVERSAL_BU_SPINE_20070924_1708

#include <boost/traversal/horizontal/one.hpp>
#include <boost/traversal/recursive/traverse.hpp>
#include <boost/traversal/recursive/detail/sequence.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct bu_spine_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse(t, false_, f, one, detail::sequence);
        }

        template<typename T, typename UnaryFunc, typename One>
        bool operator()(T& t, UnaryFunc f, One const& one) const
        {
            return traverse(t, false_, f, one, detail::sequence);
        }
    };

    bu_spine_traversal const bu_spine = {};
}}

#endif
