/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_CHOOSE_PARENT_20070924_1639)
#define BOOST_TRAVERSAL_TU_CHOOSE_PARENT_20070924_1639

namespace boost { namespace traversal { namespace detail {
    struct tu_choose_parent_impl
    {
        template<
            typename T,
            typename State,
            typename InUnaryFunc, 
            typename OutUnaryFunc, 
            typename OneImplementation, 
            typename RecursiveUnaryFunc,
            typename Parent>
        State operator()(T& t, State state, InUnaryFunc in, OutUnaryFunc out, 
                        OneImplementation one, RecursiveUnaryFunc rec, Parent& parent) const
        {
            state = in(state, t, parent);
            if(state.second)
                return state;

            state = one(t, rec.rebind(t), state.first);
            if(state.second)
                return state;

            return out(state, t, parent);
        }
    };

    tu_choose_parent_impl const tu_choose_parent = {};
}}}

#endif
