/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_ONCE_20070922_1906)
#define BOOST_TRAVERSAL_ONCE_20070922_1906

#include <boost/traversal/horizontal/one.hpp>
#include <boost/traversal/recursive/traverse.hpp>
#include <boost/traversal/recursive/detail/choose.hpp>
#include <boost/traversal/functional/false.hpp>

namespace boost { namespace traversal {
    struct once_traversal
    {
        typedef bool result_type;

        template<typename T, typename UnaryFunc>
        bool operator()(T& t, UnaryFunc f) const
        {
            return traverse(t, f, false_, one, detail::choose);
        }

        template<typename T, typename UnaryFunc, typename One>
        bool operator()(T& t, UnaryFunc f, One const& one) const
        {
            return traverse(t, f, false_, one, detail::choose);
        }
    };

    once_traversal const once = {};
}}

#endif
