/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_REVERSE_STOP_20070922_1825)
#define BOOST_TRAVERSAL_TU_REVERSE_STOP_20070922_1825

#include <boost/traversal/horizontal/tu_reverse_all.hpp>
#include <boost/traversal/recursive/tu_traverse.hpp>
#include <boost/traversal/recursive/detail/tu_choose.hpp>
#include <boost/traversal/functional/pass_through.hpp>

namespace boost { namespace traversal {
    struct tu_reverse_stop_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State>
        struct result<tu_reverse_stop_traversal(T&, UnaryFunc, State)>
        {
            typedef State type;
        };

        template<typename T, typename UnaryFunc, typename State, typename TuAll>
        struct result<tu_reverse_stop_traversal(T&, UnaryFunc, State, TuAll)>
        {
            typedef State type;
        };

        template<typename T, typename State, typename UnaryFunc>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f) const
        {
            return tu_traverse(t, state, f, 
                               pass_through, tu_reverse_all, detail::tu_choose);
        }

        template<typename T, typename State, typename UnaryFunc, typename TuAll>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f, TuAll const& tu_reverse_all) const
        {
            return tu_traverse(t, state, f, 
                               pass_through, tu_reverse_all, detail::tu_choose);
        }
    };

    tu_reverse_stop_traversal const tu_reverse_stop = {};
}}

#endif
