/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_TU_SPINE_PARENT_20070922_1825)
#define BOOST_TRAVERSAL_TU_SPINE_PARENT_20070922_1825

#include <boost/traversal/horizontal/tu_one.hpp>
#include <boost/traversal/recursive/tu_traverse_parent.hpp>
#include <boost/traversal/recursive/detail/tu_choose_parent.hpp>
#include <boost/traversal/functional/pass_through.hpp>

namespace boost { namespace traversal {
    struct tu_spine_parent_traversal
    {
        template<typename Sig>
        struct result;

        template<typename T, typename UnaryFunc, typename State>
        struct result<tu_spine_parent_traversal(T&, UnaryFunc, State)>
        {
            typedef State type;
        };

        template<typename T, typename UnaryFunc, typename State, typename TuOne>
        struct result<tu_spine_parent_traversal(T&, UnaryFunc, State, TuOne)>
        {
            typedef State type;
        };

        template<typename T, typename State, typename UnaryFunc>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f) const
        {
            return tu_traverse_parent(t, state, f, 
                               pass_through, tu_one, detail::tu_choose_parent);
        }

        template<typename T, typename State, typename UnaryFunc, typename TuOne>
        std::pair<State, bool>
        operator()(T& t, State state, UnaryFunc f, TuOne const& tu_one) const
        {
            return tu_traverse_parent(t, state, f, 
                               pass_through, tu_one, detail::tu_choose_parent);
        }
    };

    tu_spine_parent_traversal const tu_spine_parent = {};
}}

#endif
