/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#if !defined(BOOST_TRAVERSAL_IS_CONTAINER_20070828)
#define BOOST_TRAVERSAL_IS_CONTAINER_20070828

#include <boost/mpl/bool.hpp>

#include <vector>
#include <list>
#include <deque>

namespace boost { namespace traversal {
    namespace traits
    {
        template<typename T>
        struct is_container
            : boost::mpl::false_
        {};

        template<typename T, typename A>
        struct is_container<std::vector<T, A> >
            : boost::mpl::true_
        {};

        template<typename T, typename A>
        struct is_container<std::list<T, A> >
            : boost::mpl::true_
        {};

        template<typename T, typename A>
        struct is_container<std::deque<T, A> >
            : boost::mpl::true_
        {};
    }
}}

#endif
