/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/traversal/recursive/bu_tu_once.hpp>
#include <boost/detail/lightweight_test.hpp>

#include <vector>

using namespace boost;

namespace
{
    struct tu_add_one_int
    {
        template<typename U, typename State>
        State operator()(State state, U& u) const
        {
            return state;
        }

        template<typename State>
        State operator()(State state, int i) const
        {
            state.first += i;
            return std::make_pair(state.first, true);
        }
    };
}

int main()
{
    std::vector<std::vector<int> > v;
    v.push_back(std::vector<int>(1, 101));
    v.push_back(std::vector<int>(1, 202));

    std::pair<int, bool> const v_res = traversal::bu_tu_once(v, 1, tu_add_one_int());
    BOOST_TEST(v_res.first == 1 + 101);
    return boost::report_errors();
}
