/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/traversal/recursive/spine.hpp>
#include <boost/detail/lightweight_test.hpp>

#include <vector>

using namespace boost;

namespace
{
    // Work down first elements, incrementing int at end
    struct spine_function
    {
        template<typename T>
        bool operator()(T&) const
        {
            return true;
        }

        bool operator()(int& i) const
        {
            ++i;
            return true;
        }
    };
}

int main()
{
    std::vector<std::vector<int> > v;
    v.push_back(std::vector<int>(1, 0));
    v.push_back(std::vector<int>(1, 0));

    traversal::spine(v, spine_function());

    BOOST_TEST(v[0][0] == 1);
    BOOST_TEST(v[1][0] == 0);
    
    return boost::report_errors();
}
