/*=============================================================================
    Copyright (c) 2007-2008 Dan Marsden

    Distributed under the Boost Software License, Version 1.0. (See accompanying 
    file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include <boost/traversal/recursive/tu_reverse_once_parent.hpp>
#include <boost/detail/lightweight_test.hpp>

#include <vector>

using namespace boost;

namespace
{
    struct tu_add_all_ints
    {
        template<typename U, typename State, typename Parent>
        State operator()(State state, U& u, Parent&) const
        {
            return state;
        }

        template<typename State, typename Parent>
        State operator()(State state, int& i, Parent&) const
        {
            state.first += i;
            return state;
        }
    };
}

int main()
{
    std::vector<std::vector<int> > v;
    v.push_back(std::vector<int>(1, 101));
    v.push_back(std::vector<int>(1, 202));

    std::pair<int, bool> const v_res = traversal::tu_reverse_once_parent(v, 1, tu_add_all_ints());
    BOOST_TEST(v_res.first == 1 + 202);
    return boost::report_errors();
}
